## dynolog-0.5.0.tar.gz

=== CMakeLists.txt ===
# Copyright (c) Meta Platforms, Inc. and affiliates.
cmake_minimum_required(VERSION 3.16)

project(Dynolog VERSION 1.0)
option(BUILD_TESTS "Build the unit tests" ON)
option(USE_ODS_GRAPH_API "Enable logger to Meta ODS using public Graph API."
OFF)
option(USE_JSON_GENERATED_PERF_EVENTS "Add performance events generated using
Intel json spec, see hbt/src/perf_event/json_events/intel"
OFF)
option(USE_PROMETHEUS "Enable logging to prometheus, this requires
prometheus-cpp to be installed on the system"
OFF)

if(USE_PROMETHEUS)
  find_package(prometheus-cpp CONFIG REQUIRED)
endif()

file(READ "version.txt" DYNOLOG_VERSION)
string(STRIP ${DYNOLOG_VERSION} DYNOLOG_VERSION)

execute_process (
  COMMAND git rev-parse --short HEAD
  OUTPUT_VARIABLE DYNOLOG_GIT_REV
  OUTPUT_STRIP_TRAILING_WHITESPACE
)

set(DYNOLOG_VERSION "\"${DYNOLOG_VERSION}\"")
set(DYNOLOG_GIT_REV "\"${DYNOLOG_GIT_REV}\"")
message("Dynolog version = ${DYNOLOG_VERSION}")
message("Dynolog git rev = ${DYNOLOG_GIT_REV}")

set(CMAKE_VERBOSE_MAKEFILE ON)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_POSITION_INDEPENDENT_CODE True)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread")

if(BUILD_TESTS)
  enable_testing()
  add_subdirectory("third_party/googletest" "third_party/googletest")
endif()

include_directories(".")
add_subdirectory(dynolog)
add_subdirectory(cli)
# The following dummy depdendency ensures the cli is built
add_dependencies(dynolog_lib dyno)
add_subdirectory(hbt)

# Third party deps
set(BUILD_SHARED_LIBS OFF CACHE INTERNAL "")
set(BUILD_SAMPLES OFF CACHE BOOL "")
set(BUILD_TEST OFF CACHE BOOL "")
set(BUILD_SHARED_LIBS OFF CACHE BOOL "")

set(BUILD_TESTING OFF CACHE BOOL "")
set(WITH_GFLAGS OFF CACHE BOOL "")
add_subdirectory(third_party/glog)
target_link_libraries(dynolog_lib PUBLIC glog::glog)

set(GFLAGS_BUILD_TESTING OFF CACHE BOOL "")
add_subdirectory(third_party/gflags)
target_link_libraries(dynolog_lib PUBLIC gflags::gflags)

# https://github.com/nlohmann/json#cmake
set(JSON_BuildTests OFF CACHE INTERNAL "")
add_subdirectory(third_party/json)
target_link_libraries(dynolog_lib PUBLIC nlohmann_json::nlohmann_json)

add_subdirectory(third_party/pfs)
target_include_directories(dynolog_lib PUBLIC third_party/pfs/include)
target_link_libraries(dynolog_lib PUBLIC pfs)

add_subdirectory(third_party/fmt)
target_link_libraries(dynolog_lib PUBLIC fmt::fmt)

if(USE_ODS_GRAPH_API)
  add_subdirectory(third_party/cpr)
  target_link_libraries(dynolog_lib PUBLIC cpr::cpr)
endif()

=== cli/CMakeLists.txt ===
# Copyright (c) Meta Platforms, Inc. and affiliates.

# Rust project build

# Locate cargo instance
find_program(CARGO cargo)

set(ARGS --target-dir ${CMAKE_BINARY_DIR})

# Add release or debug args
if (CMAKE_BUILD_TYPE STREQUAL "Release")
    set(ARGS ${ARGS} --release)
endif()

add_custom_target(
    dyno
    COMMAND ${CARGO} build ${ARGS}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

=== hbt/CMakeLists.txt ===
# Copyright (c) Meta Platforms, Inc. and affiliates.
cmake_minimum_required(VERSION 3.16)

add_subdirectory(src)

=== dynolog/src/CMakeLists.txt ===
# Copyright (c) Meta Platforms, Inc. and affiliates.

cmake_minimum_required(VERSION 3.16)
add_definitions(-DDYNOLOG_VERSION=${DYNOLOG_VERSION} -DDYNOLOG_GIT_REV=${DYNOLOG_GIT_REV})

message("Use Prometheus = ${USE_PROMETHEUS}")
message("Use ODS Graph API = ${USE_ODS_GRAPH_API}")

# our build script will first create a src/ dir where all source code will exist
file (GLOB dynolog_src "*.h" "*.cpp")

# Remove main from library, only needed for exec.
list(REMOVE_ITEM dynolog_src "${CMAKE_CURRENT_SOURCE_DIR}/Main.cpp")
add_library(dynolog_lib ${dynolog_src})

if(USE_ODS_GRAPH_API)
  target_compile_options(dynolog_lib PUBLIC "-DUSE_GRAPH_ENDPOINT")
endif()

if(USE_PROMETHEUS)
  find_package(prometheus-cpp CONFIG REQUIRED)
  add_definitions(-DUSE_PROMETHEUS)
  target_link_libraries(dynolog_lib PRIVATE prometheus-cpp::pull)
endif()

target_link_libraries(dynolog_lib PUBLIC Monitor)
target_link_libraries(dynolog_lib PUBLIC BuiltinMetrics)

add_subdirectory(rpc)

add_subdirectory(ipcfabric)
target_link_libraries(dynolog_lib PUBLIC dynolog_ipcfabric_lib)

# depends on ipcfabric
add_subdirectory(tracing)
target_link_libraries(dynolog_lib PUBLIC dynolog_ipcmonitor_lib)

add_subdirectory(gpumon)
target_link_libraries(dynolog_lib PUBLIC dynolog_dcgm_lib "-ldl")

add_subdirectory(rdmamon)
target_link_libraries(dynolog_lib PUBLIC dynolog_rdmamon_lib)

add_subdirectory(metric_frame)

add_executable(dynolog Main.cpp)
target_link_libraries(dynolog PRIVATE dynolog_lib dynolog_rpc_lib)

=== dynolog/tests/CMakeLists.txt ===
# Copyright (c) Meta Platforms, Inc. and affiliates.

include(${PROJECT_SOURCE_DIR}/testing/BuildTests.cmake)

dynolog_add_test(KernelCollecterTest KernelCollecterTest.cpp)
if(USE_PROMETHEUS)
  add_definitions(-DUSE_PROMETHEUS)
  dynolog_add_test(PrometheusLoggerTest PrometheusLoggerTest.cpp)
endif()

add_subdirectory(rpc)
add_subdirectory(tracing)
add_subdirectory(metric_frame)

=== dynolog/src/gpumon/CMakeLists.txt ===
# Copyright (c) Meta Platforms, Inc. and affiliates.

add_library(dynolog_dcgm_lib
    DcgmApiStub.cpp DcgmApiStub.h
    DcgmGroupInfo.cpp DcgmGroupInfo.h
    Utils.h Utils.cpp
    Entity.cpp Entity.h
    dcgm_fields.h
    dcgm_agent.h
    dcgm_errors.h
    dcgm_structs.h
    dcgm_api_export.h
)
target_include_directories(dynolog_dcgm_lib
    INTERFACE ${CMAKE_CURRENT_SOURCE_DIR}
)
target_include_directories(dynolog_dcgm_lib PUBLIC
                            ${PROJECT_SOURCE_DIR}/third_party/pfs/include)
target_link_libraries(dynolog_dcgm_lib PUBLIC gflags::gflags)
target_link_libraries(dynolog_dcgm_lib PUBLIC glog::glog)
target_link_libraries(dynolog_dcgm_lib PUBLIC nlohmann_json::nlohmann_json)
target_link_libraries(dynolog_dcgm_lib PUBLIC pfs)

=== dynolog/src/ipcfabric/CMakeLists.txt ===
# Copyright (c) Meta Platforms, Inc. and affiliates.

add_library (dynolog_ipcfabric_lib INTERFACE)

=== dynolog/src/rdmamon/CMakeLists.txt ===
# Copyright (c) Meta Platforms, Inc. and affiliates.

file (GLOB dynolog_rdmamon_files "*.h" "*.cpp")
add_library(dynolog_rdmamon_lib ${dynolog_rdmamon_files})
target_link_libraries(dynolog_rdmamon_lib PUBLIC gflags::gflags)
target_link_libraries(dynolog_rdmamon_lib PUBLIC glog::glog)
target_link_libraries(dynolog_rdmamon_lib PUBLIC fmt::fmt)

=== dynolog/src/rpc/CMakeLists.txt ===
# Copyright (c) Meta Platforms, Inc. and affiliates.

add_library(dynolog_rpc_lib STATIC
    SimpleJsonServer.cpp SimpleJsonServer.h
    ${CMAKE_CURRENT_SOURCE_DIR}/../ServiceHandler.h
)
target_include_directories(dynolog_rpc_lib
    INTERFACE ${CMAKE_CURRENT_SOURCE_DIR}
)

target_include_directories(dynolog_rpc_lib
    PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/..
)
target_link_libraries(dynolog_rpc_lib PRIVATE dynolog_lib)
target_link_libraries(dynolog_rpc_lib PUBLIC gflags::gflags)
target_link_libraries(dynolog_rpc_lib PUBLIC glog::glog)
target_link_libraries(dynolog_rpc_lib PUBLIC nlohmann_json::nlohmann_json)
target_link_libraries(dynolog_rpc_lib PUBLIC fmt::fmt)

=== dynolog/src/tracing/CMakeLists.txt ===
# Copyright (c) Meta Platforms, Inc. and affiliates.

add_library (dynolog_ipcmonitor_lib IPCMonitor.cpp IPCMonitor.h
  ${CMAKE_CURRENT_SOURCE_DIR}/../LibkinetoConfigManager.h
)

target_include_directories(dynolog_ipcmonitor_lib
    INTERFACE ${CMAKE_CURRENT_SOURCE_DIR}
)
target_include_directories(dynolog_ipcmonitor_lib
    PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/..
)

target_link_libraries(dynolog_ipcmonitor_lib PUBLIC glog::glog)
target_link_libraries(dynolog_ipcmonitor_lib PUBLIC dynolog_ipcfabric_lib)

=== dynolog/tests/metric_frame/CMakeLists.txt ===
# (c) Meta Platforms, Inc. and affiliates. Confidential and proprietary.
dynolog_add_test(TextTableTest TextTableTest.cpp)
target_link_libraries(TextTableTest PRIVATE text_table)

dynolog_add_test(MetricSeriesTest MetricSeriesTest.cpp)
target_link_libraries(MetricSeriesTest PRIVATE metric_series)

dynolog_add_test(MetricValuesTest MetricValuesTest.cpp)
target_link_libraries(MetricValuesTest PRIVATE metric_values)

dynolog_add_test(MetricFrameTsUnitTest MetricFrameTsUnitTest.cpp)
target_link_libraries(MetricFrameTsUnitTest PRIVATE metric_frame_ts_unit)

dynolog_add_test(MetricFrameTest MetricFrameTest.cpp)
target_link_libraries(MetricFrameTest PRIVATE metric_frame)

=== dynolog/tests/tracing/CMakeLists.txt ===
# Copyright (c) Meta Platforms, Inc. and affiliates.

dynolog_add_test(IPCMonitorTest IPCMonitorTest.cpp)

target_link_libraries(IPCMonitorTest PRIVATE glog::glog)
target_link_libraries(IPCMonitorTest PRIVATE dynolog_ipcmonitor_lib)
target_link_libraries(IPCMonitorTest PRIVATE dynolog_lib)

=== scripts/debian/control ===
Package: dynolog
Version: __VERSION__
Architecture: amd64
Homepage: https://github.com/facebookincubator/dynolog
Maintainer: bcoutinho@meta.com
Description: Dynolog is an observability daemon for system monitoring and profiling.
 * Dynolog support monitoring for heterogenous CPU/GPU platforms.
 * Integrates with pytorch and can trigger traces for distributed training applications.
